/*
 * State.java
 *
 * Created on 7. říjen 2006, 12:08
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package misionarikanibalove;

/**
 *
 * @author pirko
 */
public class State {
    
    private int startMis;
    private int startKan;
    private boolean boatAtStart;
    private int endMis;
    private int endKan;
    
    /** Creates a new instance of State */
    public State() {
    }
    
    /**
     * Zkontroluje intergitu a taky spravnost stavu.
     * @return false pokud je někde záporný počet lidí a také pokud je někde převaha kanibalu
     */
    public boolean isOk() {
        if (startMis < 0 || startKan < 0 || endMis < 0 || endKan < 0)
            return false;
        else if (startMis < startKan && startMis > 0)
            return false;
        else if (endMis < endKan && endMis > 0)
            return false;
        else 
            return true;
    }
    
    public boolean isFinished() {
        return startMis == 0 && startKan == 0;
    }

    public int getStartMis() {
        return startMis;
    }

    public void setStartMis(int startMis) {
        this.startMis = startMis;
    }

    public int getStartKan() {
        return startKan;
    }

    public void setStartKan(int startKan) {
        this.startKan = startKan;
    }

    public boolean isBoatAtStart() {
        return boatAtStart;
    }

    public void setBoatAtStart(boolean boatAtStart) {
        this.boatAtStart = boatAtStart;
    }
    
    public boolean isBoatAtEnd() {
        return !boatAtStart;
    }

    public void setBoatAtEnd(boolean boatAtEnd) {
        this.boatAtStart = !boatAtEnd;
    }

    public int getEndMis() {
        return endMis;
    }

    public void setEndMis(int endMis) {
        this.endMis = endMis;
    }

    public int getEndKan() {
        return endKan;
    }

    public void setEndKan(int endKan) {
        this.endKan = endKan;
    }

    public String toString() {
        return "("+getStartMis()+","+getStartKan()+","+
                (isBoatAtStart()?1:0)+")"+" "+
                "("+getEndMis()+","+getEndKan()+","+
                (isBoatAtEnd()?1:0)+")";
    }
    
    public boolean equals(Object o) {
        return o.toString().equals(toString());
    }
}
